VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWatchFileSystem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

            '###############################################
            '# Timer in Klassenmodul: vbaccelerator.com    #
            '###############################################

'Mgliche berwachungen sind:
'FILE_NOTIFY_CHANGE_ATTRIBUTES, FILE_NOTIFY_CHANGE_DIR_NAME, FILE_NOTIFY_CHANGE_FILE_NAME,
'FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_NOTIFY_CHANGE_SECURITY und FILE_NOTIFY_CHANGE_SIZE

Public Event Change(NameChanged As Boolean, DirNameChanged As Boolean, SizeChanged As Boolean)

Private WithEvents cTmr As clsTimer
Attribute cTmr.VB_VarHelpID = -1

Private hCHANGE_DIRNAME As Long
Private hCHANGE_FILENAME As Long
Private hCHANGE_SIZE As Long

Private WatchPath As String
Private SubDirs As Long
Private Started As Boolean

Private Sub cTmr_ThatTime()

Dim bolNameChanged As Boolean
Dim bolDirNameChanged As Boolean
Dim bolSizeChanged As Boolean
Const WAIT_DELAY As Long = 0&

If Not Started Then
    'Erst Handle erzeugen
    hCHANGE_DIRNAME = FindFirstChangeNotification(WatchPath, SubDirs&, FILE_NOTIFY_CHANGE_DIR_NAME)
    hCHANGE_FILENAME = FindFirstChangeNotification(WatchPath, SubDirs&, FILE_NOTIFY_CHANGE_FILE_NAME)
    hCHANGE_SIZE = FindFirstChangeNotification(WatchPath, SubDirs&, FILE_NOTIFY_CHANGE_SIZE)
                 
    If hCHANGE_DIRNAME <> INVALID_HANDLE_VALUE And hCHANGE_FILENAME <> INVALID_HANDLE_VALUE And hCHANGE_SIZE <> INVALID_HANDLE_VALUE Then
        Started = True
    End If
Else
    bolDirNameChanged = CheckForChange(hCHANGE_DIRNAME, WAIT_DELAY)
    bolNameChanged = CheckForChange(hCHANGE_FILENAME, WAIT_DELAY)
    bolSizeChanged = CheckForChange(hCHANGE_SIZE, WAIT_DELAY)
    
    If bolSizeChanged Then
        bolDirNameChanged = False
        bolNameChanged = False
    End If
    
    If bolNameChanged Then
        bolDirNameChanged = False
    End If
        
    RaiseEvent Change(bolNameChanged, bolDirNameChanged, bolSizeChanged)
        
    If hCHANGE_DIRNAME = 0 Or hCHANGE_FILENAME = 0 Or hCHANGE_SIZE = 0 Then
        Call FindCloseChangeNotification(hCHANGE_DIRNAME)
        Call FindCloseChangeNotification(hCHANGE_FILENAME)
        Call FindCloseChangeNotification(hCHANGE_SIZE)
        Started = False
    End If
End If

End Sub

Public Sub Init(Path$, SubTrees As Boolean)
Attribute Init.VB_Description = "Startet die berwachung des Dateisystems."

SubDirs = IIf(SubTrees, 1, 0)
WatchPath = Path & Chr$(0)
Started = False
   
'Timer initialisieren
Set cTmr = New clsTimer
cTmr.Interval = 1500
  
End Sub

Private Function CheckForChange(ByVal hChangeObject, ByVal nWait&) As Boolean
 
Select Case WaitForSingleObject(hChangeObject, nWait)
    Case WAIT_OBJECT_0
    CheckForChange = True
    Call FindNextChangeNotification(hChangeObject)
    
    Case Else
    CheckForChange = False
End Select

End Function

Public Sub Terminate()
Attribute Terminate.VB_Description = "Beendet die berwachung des Dateisystems."

If hCHANGE_DIRNAME <> 0 Or hCHANGE_FILENAME <> 0 Or hCHANGE_SIZE <> 0 Then
    Call FindCloseChangeNotification(hCHANGE_DIRNAME)
    Call FindCloseChangeNotification(hCHANGE_FILENAME)
    Call FindCloseChangeNotification(hCHANGE_SIZE)
    Started = False
End If

End Sub
